#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>

const char* cmdname;

int main(int argc, const char* argv[]){
	cmdname = *argv++; --argc;

	if(argc != 1) {
		printf("Zu wenig Argumente!!\n");
		exit(1);
	}

	const char* file = *argv++; --argc;

	int fd = open(file, O_RDWR);
	if(fd<0) {
		printf("Fehler beim öffnen der Datei!!\n");
		exit(1);
	}

	struct stat statbuf;
	if(fstat(fd,&statbuf)<0){
		//Fehler
	}

	off_t nbytes = statbuf.st_size;

	unsigned char* buf = (unsigned char*) mmap(0, nbytes, PROT_READ||PROT_WRITE, MAP_SHARED, fd, 0);
	if(buf == MAP_FAILED) {
	 	printf("mmap failed!!\n");
	}

	for(unsigned char* cp=buf; cp<buf+nbytes; ++cp) {
		unsigned char ch = *cp;
		printf("%c",ch);
	}


	munmap(buf,nbytes);
 	close(fd);

	return 0;
}
